Watch this video to know how to integrate Razorpay Payment Gateway on your Go-based website.
Sample App
GitHub Repository
Project Structure
Before you begin, we recommend you check the Go Sample App, created using the video tutorial, and verify that your project contains the following files:- Create a Razorpay account.
- Generate the API Keys from the Dashboard. To go live with the integration and start accepting real payments, generate Live Mode API Keys and replace them in the integration.
- Know about the Payment Flow and follow these integration steps:
1. Build Integration
2. Test Integration
3. Go-live Checklist
1. Build Integration
1 Create an Order in Server
1 Create an Order in Server
- An order should be created for every payment.
- You can create an order using the Orders API in the app.js file. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to checkout in the index.html file. This ties the Order with the payment and secures the request from being tampered.
1.1 Sample Code
1.1 Sample Code
main.go and add the API code given below:1.2 Request Parameters
1.2 Request Parameters
amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is ₹299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.currency mandatory
: string The currency in which the transaction should be made. See the list of supported currencies. Length must be 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7000 is to be received from the customer in two installments of #1 - ₹5000, #2 - ₹2000 then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Know more about Orders API.1.3 Response Parameters
1.3 Response Parameters
1.4 Error Response Parameters
1.4 Error Response Parameters
2 Add Checkout Options
2 Add Checkout Options
2.1 Callback URL or Handler Function
2.1 Callback URL or Handler Function
2.3 Checkout Options
2.3 Checkout Options
key mandatory
: string API Key ID generated from the Dashboard.amount mandatory
: integer Payment amount in the smallest currency subunit. For example, if the amount to be charged is , enter 222250 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.currency mandatory
: string The currency in which the payment should be made by the customer. See the list of supported currencies.name mandatory
: string Your Business/Enterprise name shown on the Checkout form. For example, Acme Corp.description optional
: string Description of the purchase item shown on the Checkout form. It should start with an alphanumeric character.image optional
: string Link to an image (usually your business logo) shown on the Checkout form. Can also be a base64 string if you are not loading the image from a network.order_id mandatory
: string Order ID generated via Orders API.prefill
: object You can prefill the following details at Checkout.- Autofill customer contact details, especially phone number to ease form completion. Include customer’s phone number in the
contactparameter of the JSON request’sprefillobject. Format: +(country code)(phone number). Example: “contact”: “+919000090000”. - This is not applicable if you do not collect customer contact details on your website before checkout, have Shopify stores or use any of the no-code apps.
name optional
: string Cardholder’s name to be prefilled if customer is to make card payments on Checkout. For example, Gaurav Kumar.email optional
: string Email address of the customer.contact optional
: string Phone number of the customer. The expected format of the phone number is + {country code}{phone number}. If the country code is not specified, 91 will be used as the default value. This is particularly important while prefilling contact of customers with phone numbers issued outside India. Examples:- +14155552671 (a valid non-Indian number)
- +919977665544 (a valid Indian number).
If 9977665544 is entered,+91is added to it as +919977665544.
method optional
: string Pre-selection of the payment method for the customer. Will only work if contact and email are also prefilled. Possible values:cardnetbankingwalletupiemi
notes optional
: object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).theme
: object Thematic options to modify the appearance of Checkout.color optional
: string Enter your brand colour’s HEX code to alter the text, payment method icons and CTA (call-to-action) button colour of the Checkout form.backdrop_color optional
: string Enter a HEX code to change the Checkout’s backdrop colour.modal
: object Options to handle the Checkout modal.backdropclose optional
: boolean Indicates whether clicking the translucent blank space outside the Checkout form should close the form. Possible values:true: Closes the form when your customer clicks outside the checkout form.false(default): Does not close the form when customer clicks outside the checkout form.
escape optional
: boolean Indicates whether pressing the escape key should close the Checkout form. Possible values:true(default): Closes the form when the customer presses the escape key.false: Does not close the form when the customer presses the escape key.
handleback optional
: boolean Determines whether Checkout must behave similar to the browser when back button is pressed. Possible values:true(default): Checkout behaves similarly to the browser. That is, when the browser’s back button is pressed, the Checkout also simulates a back press. This happens as long as the Checkout modal is open.false: Checkout does not simulate a back press when browser’s back button is pressed.
confirm_close optional
: boolean Determines whether a confirmation dialog box should be shown if customers attempts to close Checkout. Possible values:true: Confirmation dialog box is shown.false(default): Confirmation dialog box is not shown.
ondismiss optional
: function Used to track the status of Checkout. You can pass a modal object with ondismiss: function()\{\} as options. This function is called when the modal is closed by the user. If retry is false, the ondismiss function is triggered when checkout closes, even after a failure.animation optional
: boolean Shows an animation before loading of Checkout. Possible values:true(default): Animation appears.false: Animation does not appear.
subscription_id optional
: string If you are accepting recurring payments using Razorpay Checkout, you should pass the relevant subscription_id to the Checkout. Know more about Subscriptions on Checkout.subscription_card_change optional
: boolean Permit or restrict customer from changing the card linked to the subscription. You can also do this from the hosted page. Possible values:true: Allow the customer to change the card from Checkout.false(default): Do not allow the customer to change the card from Checkout.
recurring optional
: boolean Determines if you are accepting recurring (charge-at-will) payments on Checkout via instruments such as emandate, paper NACH and so on. Possible values:true: You are accepting recurring payments.false(default): You are not accepting recurring payments.
callback_url optional
: string Customers will be redirected to this URL on successful payment. Ensure that the domain of the Callback URL is allowlisted.redirect optional
: boolean Determines whether to post a response to the event handler post payment completion or redirect to Callback URL. callback_url must be passed while using this parameter. Possible values:true: Customer is redirected to the specified callback URL in case of payment failure.false(default): Customer is shown the Checkout popup to retry the payment with the suggested next best option.
customer_id optional
: string Unique identifier of customer. Used for:- Local saved cards feature.
- Static bank account details on Checkout in case of Bank Transfer payment method.
remember_customer optional
: boolean Determines whether to allow saving of cards. Can also be configured via the Dashboard. Possible values:true: Enables card saving feature.false(default): Disables card saving feature.
timeout optional
: integer Sets a timeout on Checkout, in seconds. After the specified time limit, the customer will not be able to use Checkout.readonly
: object Marks fields as read-only.contact optional
: boolean Used to set the contact field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
email optional
: boolean Used to set the email field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
name optional
: boolean Used to set the name field as readonly. Possible values:true: Customer will not be able to edit this field.false(default): Customer will be able to edit this field.
hidden
: object Hides the contact details.contact optional
: boolean Used to set the contact field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
email optional
: boolean Used to set the email field as optional. Possible values:true: Customer will not be able to view this field.false(default): Customer will be able to view this field.
send_sms_hash optional
: boolean Used to auto-read OTP for cards and netbanking pages. Applicable from Android SDK version 1.5.9 and above. Possible values:true: OTP is auto-read.false(default): OTP is not auto-read.
allow_rotation optional
: boolean Used to rotate payment page as per screen orientation. Applicable from Android SDK version 1.6.4 and above. Possible values:true: Payment page can be rotated.false(default): Payment page cannot be rotated.
retry optional
: object Parameters that enable retry of payment on the checkout.enabled
: boolean Determines whether the customers can retry payments on the checkout. Possible values:true(default): Enables customers to retry payments.false: Disables customers from retrying the payment.
max_count
: integer The number of times the customer can retry the payment. We recommend you to set this to 4. Having a larger number here can cause loops to occur.config optional
: object Parameters that enable checkout configuration. Know more about how to configure payment methods on Razorpay standard checkout.display
: object Child parameter that enables configuration of checkout display language.language
: string The language in which checkout should be displayed. Possible values:en: Englishben: Bengalihi: Hindimar: Marathiguj: Gujaratitam: Tamiltel: Telugu
rzp1.open()) must be invoked by your site’s JavaScript, which may or may not be a user-driven action such as a click.2.4 Handle Payment Success and Failure
2.4 Handle Payment Success and Failure
Checkout with Callback URL
Checkout with Callback URL
- On Payment Success
- On Payment Failure
Checkout with Handler Function
Checkout with Handler Function
- On Payment Success
- On Payment Failure
2.5 Configure Payment Methods *(Optional)*
2.5 Configure Payment Methods *(Optional)*
- The payment methods are fixed and cannot be changed.
- You can configure the order or make certain payment methods prominent. Know more about configuring payment methods. Know more about configuring payment methods.
3 Store Fields in Your Server
3 Store Fields in Your Server
Success Callback
Success Callback
- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.razorpay_order_id
: string Unique identifier for the order returned by Checkout.razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.4 Verify Payment Signature
4 Verify Payment Signature
razorpay_signature returned to you by the Checkout form:- Create a signature in your server using the following attributes:
- Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct an HMAC hex digest as shown below:
- If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Use the code given below to generate signature on your server:5 Verify Payment Status
5 Verify Payment Status
captured. Refer to the payment capture settings page to know how to capture payments automatically.- Verify Status from Dashboard
- Subscribe to Webhook Events
- Poll APIs
- Log in to the Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.

2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app.
Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful.
Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others may require approval from us. Raise a request from the Dashboard to enable such payment methods.
Netbanking
Netbanking
success or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.Check the list of supported banks.UPI
UPI
success@razorpay: To make the payment successful.failure@razorpay: To fail the payment.
Cards
Cards
Domestic Cards
Use the following test cards for Indian payments:Error Scenarios
Use these test cards to simulate payment errors. See the complete list of error test cards with detailed scenarios. Check the following lists:International Cards
Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.Wallet
Wallet
success or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.Check the list of supported wallets.3. Go-live Checklist
Check the go-live checklist for Razorpay Web Standard Checkout integration. Consider these steps before taking the integration live.1 Accept Live Payments
1 Accept Live Payments
- Log in to the Razorpay Dashboard and switch to Live Mode on the menu.
- Navigate to Account & Settings → API Keys → Generate Key to generate the API Key for Live Mode.
- Download the keys and save them securely.
- Replace the Test API Key with the Live Key in the Checkout code and start accepting actual payments.
2 Payment Capture
2 Payment Capture
authorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.- Auto-capture Payments (Recommended)
- Manually Capture Payments
3 Set Up Webhooks
3 Set Up Webhooks